// Generated by CoffeeScript 2.3.1
var bindending, bindhelp, chromakey, collides, dolls, draw, draw_bounds, draw_doll, draw_pair, draw_score, enablevideos, endText, findpairs, getscore, last, mousePressed, mouseReleased, offset, pairs, picked, pickedId, preload, r, selected, setup, showingEndButton, showingResults, sources, t, uvlist;

sources = {};

VIDEOS.map(function(v, i) {
  return sources[v] = CROPS[i];
});

uvlist = [new uv(new v2(0.24, 0.11), new v2(0.5, 0.9)), new uv(new v2(0.5, 0.11), new v2(0.7, 0.9))];

chromakey = null;

t = 0;

r = 0.1;

last = 0;

selected = null;

picked = null;

pickedId = -1;

showingEndButton = false;

showingResults = false;

offset = new v2(0, 0);

pairs = [];

dolls = Object.keys(sources).map(function(k) {
  return {
    uvs: sources[k].uvs,
    name: k
  };
}).reduce((function(a, s, i) {
  return a.concat([new doll(s.name, "left", new v2(Math.random() * (1 - s.uvs[0].w * (SIZE.w / innerWidth)), Math.random() * (1 - s.uvs[0].h * (SIZE.h / innerHeight))), s.uvs[0]), new doll(s.name, "right", new v2(Math.random() * (1 - s.uvs[1].w * (SIZE.w / innerWidth)), Math.random() * (1 - s.uvs[1].h * (SIZE.h / innerHeight))), s.uvs[1])]);
}), []);

collides = function(p, d) {
  var ref, ref1;
  return (d.pos.x < (ref = p.x) && ref < d.pos.x + d.uv.w) && (d.pos.y < (ref1 = p.y) && ref1 < d.pos.y + d.uv.h);
};

draw_doll = function(t, x, y, crop, w = 1, h = 1) {
  texture(t);
  beginShape();
  vertex(x * width, y * height, 0, crop.vs[0].x, crop.vs[0].y);
  vertex(x * width + crop.w * SIZE.w * w, y * height, 0, crop.vs[1].x, crop.vs[1].y);
  vertex(x * width + crop.w * SIZE.w * w, y * height + crop.h * SIZE.h * h, 0, crop.vs[2].x, crop.vs[2].y);
  vertex(x * width, y * height + crop.h * SIZE.h * h, 0, crop.vs[3].x, crop.vs[3].y);
  return endShape(CLOSE);
};

draw_pair = function(p) {
  fill("#0555");
  stroke("#0005");
  // strokeCap PROJECT
  strokeWeight(20);
  noFill();
  beginShape(LINES);
  vertex(p.a.center.x * width, p.a.center.y * height + p.a.height * 0.42 * height, 0);
  vertex(p.b.center.x * width, p.b.center.y * height + p.b.height * 0.42 * height, 0);
  return endShape();
};

getscore = function(ps) {
  var j, len, p, wrong;
  wrong = 0;
  for (j = 0, len = ps.length; j < len; j++) {
    p = ps[j];
    if (p.a.name !== p.b.name) {
      wrong++;
      sources[p.a.name].video.pause();
      sources[p.b.name].video.pause();
    }
  }
  return ps.length / 2 - wrong / 2;
};

findpairs = function() {
  var allpaired, closest, d, i, j, l, len, len1, threshold;
  threshold = 0.3;
  for (i = j = 0, len = dolls.length; j < len; i = ++j) {
    d = dolls[i];
    d.closest = null;
    closest = dolls.reduce((function(a, v) {
      if (a.center.dist(d.center) > v.center.dist(d.center) && !d.is(v)) {
        return v;
      } else {
        return a;
      }
    }), dolls[(i + 1) % dolls.length]);
    if (closest.center.dist(d.center) < threshold) {
      d.closest = closest;
    }
  }
  pairs = [];
  allpaired = true;
  for (i = l = 0, len1 = dolls.length; l < len1; i = ++l) {
    d = dolls[i];
    if ((d.closest != null) && (d.closest.closest != null) && d.closest.closest.is(d)) {
      pairs.push({
        a: d,
        b: d.closest
      });
    } else {
      allpaired = false;
      d.closest = null;
    }
  }
  return allpaired;
};

enablevideos = function() {
  var k, results, v;
  results = [];
  for (k in sources) {
    v = sources[k];
    results.push(v.video.loop());
  }
  return results;
};

preload = function() {
  chromakey = loadShader("shader/default.vert", "shader/chroma.frag");
  return Object.keys(sources).map(function(k) {
    var video;
    video = createVideo(`scaled/${k}.mp4`);
    // video.loop()
    video.hide();
    return sources[k].video = video;
  });
};

endText = function(s, a) {
  if (s === 0) {
    return "Have you even tried?";
  } else if (s < 3) {
    return "Look closer!";
  } else if (s < 7) {
    return "Well, it is a good start.";
  } else if (s < 9) {
    return "Not bad!";
  } else if (s < 11) {
    return "Good job!";
  } else if (s < 13) {
    return "Almost perfect!";
  } else {
    return "Wow, you are amazing!";
  }
};

bindhelp = function(b) {
  return $(b).html("?").mouseenter(function() {
    return $(b).html(HELP);
  }).mouseleave(function() {
    return $(b).html("?");
  }).click(function() {
    return $(b).html(HELP);
  });
};

bindending = function(b) {
  return $(b).off("mouseenter mouseleave click").html("all paired! show results?").click(function() {
    var all, score;
    showingResults = true;
    score = getscore(pairs);
    all = dolls.length / 2;
    return $(this).click(function() {
      return window.location.reload();
    }).html(endText(score, all) + `<br>You matched ${score} out of ${all}! <br>Try again?`);
  });
};

setup = function() {
  createCanvas(innerWidth, innerHeight, WEBGL);
  findpairs();
  $("<button>", {
    id: "start-button",
    html: "PLAY",
    click: function() {
      $("#start-button").html("").animate({
        left: 0,
        top: 0,
        margin: 0
      }, 400, function() {
        return bindhelp(this);
      });
      $("canvas").animate({
        opacity: 1
      }, 700);
      return enablevideos();
    }
  }).appendTo($("body"));
  return $(window).resize(function() {
    return window.location.reload();
  });
};

// gui = new dat.GUI()
// gui.addColor(COLORS, "chroma").onChange((c) -> chromakey.setUniform("screenColor", color(c).levels.reduce(((a, v, i) -> if i < 3 then a.concat([v / 255]) else a), [])))
draw_bounds = function(d, c) {
  fill(c);
  return rect(d.pos.x * width, d.pos.y * height, d.width * width, d.height * height);
};

draw_score = function(s, a) {
  var j, len, p, results;
  results = [];
  for (j = 0, len = pairs.length; j < len; j++) {
    p = pairs[j];
    if (p.a.name === p.b.name) {
      draw_bounds(p.a, "#0555");
      results.push(draw_bounds(p.b, "#0555"));
    } else {
      results.push(void 0);
    }
  }
  return results;
};

// if p.a.name isnt p.b.name
//   draw_bounds p.a, "#0009"
//   draw_bounds p.b, "#0009"
draw = function() {
  var colliding, d, delta, j, l, len, len1, mp, p, results;
  delta = (millis() - last) * 0.001;
  chromakey.setUniform("screenColor", color(COLORS.chroma).levels.reduce((function(a, v, i) {
    if (i < 3) {
      return a.concat([v / 255]);
    } else {
      return a;
    }
  }), []));
  last = millis();
  t = t + r * delta;
  if (t > 1) {
    t = t - 1.0;
  }
  translate(-width * 0.5, -height * 0.5);
  background("#3333");
  mp = new v2(mouseX / width, mouseY / height);
  colliding = dolls.map(function(d, i) {
    return i;
  }).filter(function(d) {
    return collides(mp, dolls[d]);
  });
  if (!showingResults) {
    push();
    if (colliding.length > 0 && (picked == null)) {
      selected = dolls[colliding.reduce((function(a, v) {
        if (dolls[a].center.dist(mp) > dolls[v].center.dist(mp)) {
          return v;
        } else {
          return a;
        }
      }), colliding[0])];
      draw_bounds(selected, "#0005");
    }
    if (picked != null) {
      if (pickedId !== dolls.length - 1 || pickedId !== -1) {
        dolls.splice(pickedId, 1);
        dolls.push(picked);
        pickedId = dolls.length - 1;
      }
      // dolls.sort((a, b) -> a.pos.y < b.pos.y)
      picked.setpos(mp.x - offset.x, mp.y - offset.y);
      draw_bounds(picked, "#0555");
      if (findpairs()) {
        if (!showingEndButton) {
          bindending($("#start-button"));
          showingEndButton = true;
        }
      } else if (showingEndButton) {
        bindhelp($("#start-button"));
        showingEndButton = false;
      }
    }
    if (pairs.length > 0) {
      for (j = 0, len = pairs.length; j < len; j++) {
        p = pairs[j];
        draw_pair(p);
      }
    }
    pop();
  } else {
    draw_score(getscore(pairs));
  }
  shader(chromakey);
  results = [];
  for (l = 0, len1 = dolls.length; l < len1; l++) {
    d = dolls[l];
    results.push(draw_doll(sources[d.source].video, d.pos.x, d.pos.y, d.uv));
  }
  return results;
};

mousePressed = function(e) {
  var d, i, j, len;
  if (!showingResults && (selected != null)) {
    picked = selected;
    for (i = j = 0, len = dolls.length; j < len; i = ++j) {
      d = dolls[i];
      if (d.is(selected)) {
        pickedId = i;
      }
    }
    offset.x = mouseX / width - selected.pos.x;
    return offset.y = mouseY / height - selected.pos.y;
  }
};

mouseReleased = function() {
  if (!showingResults && (picked != null)) {
    return picked = null;
  }
};

//# sourceMappingURL=script.js.map
